import click
import cmd2
import sys
import platform
from nwtoolkit import _plugin_list as plugin_list
from nwtoolkit.__version__ import __version__

class NWShell(cmd2.Cmd):
    def __init__(self):
        shortcuts = cmd2.DEFAULT_SHORTCUTS
        shortcuts.update({
            'exit': 'quit'
        })
        super().__init__(shortcuts=shortcuts)

        self.logo = """
    _   ___       __   ______            ____   _ __
   / | / / |     / /  /_  __/___  ____  / / /__(_) /_
  /  |/ /| | /| / /    / / / __ \/ __ \/ / //_/ / __/
 / /|  / | |/ |/ /    / / / /_/ / /_/ / / ,< / / /_
/_/ |_/  |__/|__/    /_/  \____/\____/_/_/|_/_/\__/
"""

        self.info = f"""
OS Version: {platform.platform()}
Python Version: {" ".join(str(sys.version).splitlines())}
Toolkit Version: {__version__}
Number of Plugins Loaded: {len(plugin_list)}
"""

        self.intro_message = """
Welcome to the NetWitness Global Services Toolkit. Type help or ? to list commands.
"""

        self.intro = self.logo + self.info + self.intro_message
        for plugin in plugin_list:
            print(plugin)

@click.command(help='Command shell for nwtoolkit')
@click.pass_obj
def shell(env):
    app = NWShell()
    app.cmdloop()
